Front Page / Metafunctions / Arithmetic Operations / modulus

# modulus

### Synopsis

    template<
          typename T1
        , typename T2
        >
    struct modulus
    {
        typedef unspecified type;
    };

### Description

Returns the modulus of its arguments.

### Header

    #include <boost/mpl/modulus.hpp>
    #include <boost/mpl/arithmetic.hpp>

### Model of

Numeric Metafunction

### Parameters

Parameter | Requirement | Description
--- | --- | ---
`T1`, `T2` | Integral Constant | Operation's arguments.

[Note: The requirements listed in this specification are the ones imposed by the default implementation. See Numeric Metafunction concept for the details on how to provide an implementation for a user-defined numeric type that does not satisfy the Integral Constant requirements. — end note]

### Expression semantics

For any Integral Constants `c1` and `c2`:

    typedef modulus<c1,c2>::type r;

Return type: | Integral Constant.
Precondition: | `c2::value != 0`
Semantics: | Equivalent to
    typedef integral_c<
          typeof(c1::value % c2::value)
        , ( c1::value % c2::value )
        > r;

    typedef modulus<c1,c2> r;

Return type: | Integral Constant.
Precondition: | `c2::value != 0`
Semantics: | Equivalent to
    struct r : modulus<c1,c2>::type {};

### Complexity

Amortized constant time.

### Example

    typedef modulus< int_<10>, long_<3> >::type r;
    BOOST_MPL_ASSERT_RELATION( r::value, ==, 1 );
    BOOST_MPL_ASSERT(( is_same< r::value_type, long > ));

### See also

Metafunctions, Numeric Metafunction, numeric_cast, divides, times, plus